//+-------------------------------------------------------------------------------+ 
//+-------------------------------------------------------------------------------+
#property copyright ""
#property link      ""

//
//
//
//
//

extern int    MagicNumber           = 190722;
extern int    TradeTime.startHour   = 3;
extern int    TradeTime.startMinute = 0;
extern int    TradeTime.endHour     = 23;
extern int    TradeTime.endMinute   = 0;
extern int    Trade.openAt          = 50;
extern int    Trade.takeProfit      = 70;
extern double Trade.lots            = 0.01;

//
//
//
//
//

double pipMultiplier = 1;


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()   { return(0); }
int deinit() { return(0); }
int start()
{     
   if (Digits==3 || Digits==5) 
         pipMultiplier = 10;
   else  pipMultiplier = 1;               

   //
   //
   //    time limit
   //
   //
   
      datetime startTime       = StrToTime(StringSubstr(TimeToStr(TimeCurrent()),0,10)+" 00:00")+TradeTime.startHour*3600+TradeTime.startMinute*60;
      datetime endTime         = StrToTime(StringSubstr(TimeToStr(TimeCurrent()),0,10)+" 00:00")+TradeTime.endHour*3600  +TradeTime.endMinute*60;
      bool     withinTimeLimit = (TimeCurrent()>=startTime && TimeCurrent()<=endTime);

   //
   //
   //    opened positions and orders managemenet
   //
   //
   
   bool buyStopOpened   = false;
   bool sellStopOpened  = false;
   bool buyOrderOpened  = false;
   bool sellOrderOpened = false;
   
   for(int i=0; i < OrdersTotal(); i++)
   {
      if(OrderSelect(i, SELECT_BY_POS, MODE_TRADES) == false) break;
      if(OrderMagicNumber() != MagicNumber) continue;
      if(OrderSymbol()      != Symbol())    continue;
                  
      //
      //
      //
      //
      //

      RefreshRates();                  
         if(OrderType() == OP_BUYSTOP)
         {
            if (!withinTimeLimit || (TimeDayOfYear(OrderOpenTime()) != TimeDayOfYear(TimeCurrent())))
                  OrderDelete(OrderTicket());
            else  buyStopOpened = true;
         }            
         if(OrderType() == OP_SELLSTOP)
         {
            if (!withinTimeLimit || (TimeDayOfYear(OrderOpenTime()) != TimeDayOfYear(TimeCurrent())))
                  OrderDelete(OrderTicket());
            else  sellStopOpened = true;
         }            
         if (OrderType() == OP_BUY)
         {
            if (Bid<=getOpenPrice(OrderOpenTime()))
                  OrderClose(OrderTicket(),OrderLots(),Bid,0,CLR_NONE);
            else  buyOrderOpened = true;          
         }
         if (OrderType() == OP_SELL)
         {
            if (Ask>=getOpenPrice(OrderOpenTime()))
                  OrderClose(OrderTicket(),OrderLots(),Ask,0,CLR_NONE);
            else  sellOrderOpened = true;          
         }
   }      

   //
   //
   //
   //
   //

   double tradeLots = MathMin(MathMax(Trade.lots,MarketInfo(Symbol(),MODE_MINLOT)),MarketInfo(Symbol(),MODE_MAXLOT));
   double openPrice = getOpenPrice(TimeCurrent());
      
      //
      //
      //    place new stop orders if necesary
      //
      //
      
      RefreshRates();
      if (!buyStopOpened && !buyOrderOpened && withinTimeLimit)
      {
         if (openPrice>Ask)
         {
            double openAtPrice = openPrice  +Trade.openAt*Point*pipMultiplier;
            double tpAtPrice   = openAtPrice+Trade.takeProfit*Point*pipMultiplier;
               OrderSend(Symbol(),OP_BUYSTOP,tradeLots,openAtPrice,0,0,tpAtPrice,"",MagicNumber);
         }               
      }
      if (!sellStopOpened && !sellOrderOpened && withinTimeLimit)
      {
         if (openPrice<Bid)
         {
            openAtPrice = openPrice  -Trade.openAt*Point*pipMultiplier;
            tpAtPrice   = openAtPrice-Trade.takeProfit*Point*pipMultiplier;
               OrderSend(Symbol(),OP_SELLSTOP,tradeLots,openAtPrice,0,0,tpAtPrice,"",MagicNumber);
         }               
      }
}


//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double getOpenPrice(datetime openTime)
{
   int forBar = iBarShift(Symbol(),PERIOD_D1,openTime);
             return(iOpen(Symbol(),PERIOD_D1,forBar));
}